// ,                 
//   "" 1992-2011.   

#include "stdafx.h"
#include <windows.h> 
#include <conio.h>
#include <stdio.h>

#include "zadc_int.h"						//   Zadc.dll

#define MAX_TYPE_DSP	20					//     
#define MAX_DEVICE_NAME	16					//      

int main(int argc, char* argv[])
{
	long typeDevice;						//  
	long numberDSP = 0;						//    
	long Err;								//  
	long enable;							//   /  
	long numChannelsADC;					//    
	long numWordsADC;						//   (  )    
	short *pBuffer16ADC = NULL;				//            16 
	long *pBuffer32ADC = NULL;				//           16  
	long sizeBufferADC;						//     
	long pointerADC = 0;					//        ( 2)
	long pointerADC_old = 0;				//      
	double amplifyADC0, amplifyADC1;		//       
	double resolutionADC0, resolutionADC1;	//        
	double volt0, volt1;					//     ( )
	long serial;							//   
	char deviceName[MAX_DEVICE_NAME];		//  

	//      
	for(typeDevice = 0; typeDevice < MAX_TYPE_DSP; typeDevice++)
	{
		//    
		Err = ZOpen(typeDevice, numberDSP);
		//     
		if(Err == 0)
		{
			//    
			Err = ZGetEnableADC(typeDevice, numberDSP, &enable);
			//    
			if(Err == 0 && enable != 0)
			{
				//    
				break;
			}
			//     
			else
			{
				//    
				printf("ZGetEnableADC() return Error = 0x%X\n\r", Err);
				//    
				Err = ZClose(typeDevice, numberDSP);
			}
		}
	}

	//       
	if(typeDevice >= MAX_TYPE_DSP)
	{
		//    
		printf("Device not found! Error = 0x%X\n\r", Err);
		getch();
		return 0;
	}
	//      
	else
	{
		//    ,      
		printf("Device found...\n\r");
	}

	//   
	Err = ZGetNameDevice(typeDevice, numberDSP, deviceName, MAX_DEVICE_NAME);
	//     
	if(Err != 0)
	{
		//    
		printf("ZGetNameDevice() return Error = 0x%X\n\r", Err);
		//    
		Err = ZClose(typeDevice, numberDSP);
		getch();
		return 0;
	}
	//     
	else
	{
		//   
		printf("Device name: %s\n\r", deviceName);
	}

	//    
	Err = ZGetSerialNumberDSP(typeDevice, numberDSP, &serial);
	//     
	if(Err != 0)
	{
		//    
		printf("ZGetNameDevice() return Error = 0x%X\n\r", Err);
		//    
		Err = ZClose(typeDevice, numberDSP);
		getch();
		return 0;
	}
	//     
	else
	{
		//    
		printf("Serial number: %ld\n\r", serial);
	}

	//     
	Err = ZGetQuantityChannelADC(typeDevice, numberDSP, &numChannelsADC);
	//     
	if(Err != 0)
	{
		//    
		printf("ZGetQuantityChannelADC() return Error = 0x%X\n\r", Err);
		//    
		Err = ZClose(typeDevice, numberDSP);
		getch();
		return 0;
	}
	//     
	else
	{
		//     
		printf("Quantity of ADC channel: %ld\n\r", numChannelsADC);
	}

	//       
	Err = ZSetInputADC(typeDevice, numberDSP, 0, 1);
	//     
	if(Err != 0)
	{
		//    
		printf("ZSetInputADC() return Error = 0x%X\n\r", Err);
		//    
		Err = ZClose(typeDevice, numberDSP);
		getch();
		return 0;
	}
	//     
	else
	{
		//         
		printf("First channel activation is successful...\n\r");
	}
	//      
	if(numChannelsADC > 1)
	{
		//       
		Err = ZSetInputADC(typeDevice, numberDSP, 1, 1);
		//     
		if(Err != 0)
		{
			//    
			printf("ZSetInputADC() return Error = 0x%X\n\r", Err);
			//    
			Err = ZClose(typeDevice, numberDSP);
			getch();
			return 0;
		}
		//     
		else
		{
			//        
			printf("Second channel activation is successful...\n\r");
		}
	}

	//       
	Err = ZGetAmplifyADC(typeDevice, numberDSP, 0, &amplifyADC0);
	//     
	if(Err != 0)
	{
		//    
		printf("ZGetAmplifyADC() return Error = 0x%X\n\r", Err);
		//    
		Err = ZClose(typeDevice, numberDSP);
		getch();
		return 0;
	}
	//     
	else
	{
		//       
		printf("First channel amplifier: %f\n\r", amplifyADC0);
	}
	//      
	if(numChannelsADC > 1)
	{
		//       
		Err = ZGetAmplifyADC(typeDevice, numberDSP, 1, &amplifyADC1);
		//     
		if(Err != 0)
		{
			//    
			printf("ZGetAmplifyADC() return Error = 0x%X\n\r", Err);
			//    
			Err = ZClose(typeDevice, numberDSP);
			getch();
			return 0;
		}
		//     
		else
		{
			//       
			printf("Second channel amplifier: %f\n\r", amplifyADC1);
		}
	}

	//        
	Err = ZGetDigitalResolChanADC(typeDevice, numberDSP, 0, &resolutionADC0);
	//     
	if(Err != 0)
	{
		//    
		printf("ZGetDigitalResolChanADC() return Error = 0x%X\n\r", Err);
		//    
		Err = ZClose(typeDevice, numberDSP);
		getch();
		return 0;
	}
	//     
	else
	{
		//        
		printf("First channel digital resolution: %f\n\r", resolutionADC0);
	}
	//      
	if(numChannelsADC > 1)
	{
		//         
		Err = ZGetDigitalResolChanADC(typeDevice, numberDSP, 1, &resolutionADC1);
		//     
		if(Err != 0)
		{
			//    
			printf("ZGetDigitalResolChanADC() return Error = 0x%X\n\r", Err);
			//    
			Err = ZClose(typeDevice, numberDSP);
			getch();
			return 0;
		}
		else
		{
			//        
			printf("Second channel digital resolution: %f\n\r", resolutionADC1);
		}
	}

	//      
	Err = ZGetNumberInputADC(typeDevice, numberDSP, &numChannelsADC);
	//     
	if(Err != 0)
	{
		//    
		printf("Function ZGetNumberInputADC() return Error = 0x%X\n\r", Err);
		//    
		Err = ZClose(typeDevice, numberDSP);
		getch();
		return 0;
	}
	//     
	else
	{
		//      
		printf("Quantity of activated ADC channel: %ld\n\r", numChannelsADC);
	}

	//        
	Err = ZGetWordsADC(typeDevice, numberDSP, &numWordsADC);
	//     
	if(Err != 0)
	{
		//    
		printf("ZGetWordsADC() return Error = 0x%X\n\r", Err);
		//    
		Err = ZClose(typeDevice, numberDSP);
		getch();
		return 0;
	}
	//     
	else
	{
		//        
		printf("Quantity of words: %ld\n\r", numWordsADC);
	}

	//  ,     
	if(numWordsADC == 0 || amplifyADC0 == 0 || amplifyADC1 == 0)
	{
		//    
		printf("Error DAC parameters\n\r");
		//    
		Err = ZClose(typeDevice, numberDSP);
		getch();
		return 0;
	}

	//   
	Err = ZGetBufferADC(typeDevice, numberDSP, (void**) &pBuffer16ADC, &sizeBufferADC);
	//     
	if(Err != 0)
	{
		//    
		printf("Function ZGetBufferADC() return Error = 0x%X\n\r", Err);
		//    
		Err = ZClose(typeDevice, numberDSP);
		getch();
		return 0;
	}
	pBuffer32ADC = (long*) pBuffer16ADC;

	//    
	Err = ZStopADC(typeDevice, numberDSP);
	//    
	Err = ZStartADC(typeDevice, numberDSP);

	//    
	while(!kbhit())
	{
		//      
		Sleep(500);

		//      
		Err = ZGetPointerADC(typeDevice, numberDSP, &pointerADC);
		//     
		if(Err != 0)
		{
			//    
			printf("Function ZGetPointerADC() return Error = 0x%X\n\r", Err);
			//   
			break;
		}

		//         ,       
		if(pointerADC == pointerADC_old)
			continue;

		//    
		pointerADC_old = pointerADC;

		//         
		if(pointerADC - numWordsADC * numChannelsADC < 0)
			pointerADC = sizeBufferADC + pointerADC - numWordsADC * numChannelsADC;
		else 
			pointerADC = pointerADC - numWordsADC * numChannelsADC; 

		//          ( )   
		if(numWordsADC == 1)
			volt0 = resolutionADC0 * (pBuffer16ADC[pointerADC]) / amplifyADC0;
		else
			volt0 = resolutionADC0 * (pBuffer32ADC[pointerADC / numWordsADC]) / amplifyADC0;

		//       
		printf("%+8.4f", volt0);

		//      
		if(numChannelsADC > 1)
		{
			//     
			pointerADC += numWordsADC;
			
			//     ,    
			if(pointerADC >= sizeBufferADC)
				pointerADC = pointerADC - sizeBufferADC;

			//          ( )   
			if(numWordsADC == 1)
				volt1 = resolutionADC1 * (pBuffer16ADC[pointerADC]) / amplifyADC1;
			else
				volt1 = resolutionADC1 * (pBuffer32ADC[pointerADC/numWordsADC]) / amplifyADC1;

			//       
			printf("\t%+8.4f", volt1);
		}
		printf("\n\r");
	}

	//    
	Err = ZStopADC(typeDevice, numberDSP);
	//     
	if(Err != 0)
	{
		//    
		printf("Function ZStopADC() return Error = 0x%X\n\r", Err);
	}

	//     
	if(pBuffer16ADC != NULL)
	{
		Err = ZRemBufferADC(typeDevice, numberDSP, (void**) &pBuffer16ADC);
		//     
		if(Err != 0)
		{
			//    
			printf("Function ZRemBufferADC() return Error = 0x%X\n\r", Err);
		}
	}

	//    
	Err = ZClose(typeDevice, numberDSP);
	//     
	if(Err != 0)
	{
		//    
		printf("Function ZClose() return Error = 0x%X\n\r", Err);
	}

	if(!kbhit())
		getch();

	printf("Press any key for exit...");
	getch();

 	return 0;
}
