program Test_Zadc;
{$APPTYPE CONSOLE}

uses
  SysUtils,
  Windows,
  Zadc_int;

const
  MAX_TYPE_DSP = 20;                                  //   -  
  MAX_DEVICE_NAME	= 16;				                      	//      

var
  Err: Longint;                                       //  
  typeDevice: Longint;                                //  
  numberDSP: Longint = 0;                             //   
  enable: Longint;                                    //   /  
  deviceName: array [0..MAX_DEVICE_NAME] of Char;     //  
  serial: Longint;                                    //   
  numChannelsADC: Longint;					                  //    
  amplifyADC: array [0..1] of Double;                 //      
  resolutionADC: array [0..1] of Double;              //        
  numWordsADC: Longint;                               //   (  )    
  sizeBufferADC: Longint;		                          //     
  pointerADC: Longint = 0;			                      //       
  pointerADC_old: Longint = 0;	                      //      
  pBuffer: Pointer = 0;				                        //       
  pBuffer16ADC: ^Smallint = 0;                        //            16 
  pBuffer32ADC: ^Longint = 0;		                      //           16 
  volt: array [0..1] of Double;					              //     ( )
  sampleADC: array [0..1] of Longint;                 //      ( )
  sample16ADC: array [0..1] of Smallint;              //          16 ( )
  sample32ADC: array [0..1] of Longint;               //         16 ( )
  proc: Boolean = True;

begin
  //      
  for typeDevice := 0 to MAX_TYPE_DSP - 1 do
  begin
    //    
    Err := ZOpen(typeDevice, numberDSP);
    //     
    if Err = 0 then
    begin
      //    
      Err := ZGetEnableADC(typeDevice, numberDSP, enable);
      //    
      if (Err = 0) and (enable <> 0) then
        //    
        break
      //     
      else
      begin
        //    
        WriteLn('ZGetEnableADC() return Error = 0x', IntToHex(Err, 2));
        //    
        Err := ZClose(typeDevice, numberDSP);
      end;
    end
  end;

  //       
	if typeDevice >= MAX_TYPE_DSP then
	begin
		//    
    WriteLn('Device not found! Error = 0x', IntToHex(Err, 2));
		ReadLn;
		Exit;
	end
	//      
	else
    //    ,      
    WriteLn('Device found...');

  //   
  Err := ZGetNameDevice(typeDevice, numberDSP, deviceName, MAX_DEVICE_NAME);
  //     
	if Err <> 0 then
	begin
		//    
    WriteLn('ZGetNameDevice() return Error = 0x', IntToHex(Err, 2));
		//    
		Err := ZClose(typeDevice, numberDSP);
    ReadLn;
		Exit;
	end
	//     
	else
  	//   
    WriteLn('Device name: ', deviceName);

  //    
	Err := ZGetSerialNumberDSP(typeDevice, numberDSP, serial);
	//     
	if Err <> 0 then
	begin
		//    
    WriteLn('ZGetNameDevice() return Error = 0x', IntToHex(Err, 2));
		//    
		Err := ZClose(typeDevice, numberDSP);
	  ReadLn;
		Exit;
	end
	//     
	else
		//    
    WriteLn('Serial number: ', serial);

  //     
	Err := ZGetQuantityChannelADC(typeDevice, numberDSP, numChannelsADC);
	//     
	if Err <> 0 then
	begin
		//    
    WriteLn('ZGetQuantityChannelADC() return Error = 0x', IntToHex(Err, 2));
		//    
		Err := ZClose(typeDevice, numberDSP);
	  ReadLn;
	  Exit;
  end
	//     
	else
		//     
    WriteLn('Quantity of ADC channel: ', numChannelsADC);

	//       
	Err := ZSetInputADC(typeDevice, numberDSP, 0, 1);
	//     
	if Err <> 0 then
  begin
		//    
    WriteLn('ZSetInputADC() return Error = 0x', IntToHex(Err, 2));
		//    
		Err := ZClose(typeDevice, numberDSP);
		ReadLn;
	  Exit;
	end
	//     
	else
		//         
    Writeln('First channel activation is successful...');

	//      
	if numChannelsADC > 1 then
	begin
		//       
		Err := ZSetInputADC(typeDevice, numberDSP, 1, 1);
		//     
		if Err <> 0 then
		begin
			//    
      WriteLn('ZSetInputADC() return Error = 0x', IntToHex(Err, 2));
			//    
			Err := ZClose(typeDevice, numberDSP);
			ReadLn;
	    Exit;
		end
		//     
		else
			//        
      Writeln('Second channel activation is successful...');
	end;

	//       
	Err := ZGetAmplifyADC(typeDevice, numberDSP, 0, amplifyADC[0]);
	//     
	if Err <> 0 then
	begin
		//    
    WriteLn('ZGetAmplifyADC() return Error = 0x', IntToHex(Err, 2));
		//    
		Err := ZClose(typeDevice, numberDSP);
		ReadLn;
    Exit;
	end
	//     
	else
		//       
    WriteLn('First channel amplifier: ', amplifyADC[0]:12:6);

	//      
	if numChannelsADC > 1 then
	begin
		//       
		Err := ZGetAmplifyADC(typeDevice, numberDSP, 1, amplifyADC[1]);
		//     
		if Err <> 0 then
		begin
			//    
      WriteLn('ZGetAmplifyADC() return Error = 0x', IntToHex(Err, 2));
			//    
			Err := ZClose(typeDevice, numberDSP);
			ReadLn;
      Exit;
		end
		//     
		else
			//       
      WriteLn('Second channel amplifier: ', amplifyADC[1]:12:6);
	end;

	//        
	Err := ZGetDigitalResolChanADC(typeDevice, numberDSP, 0, resolutionADC[0]);
	//     
	if Err <> 0 then
	begin
		//    
    WriteLn('ZGetDigitalResolChanADC() return Error = 0x', IntToHex(Err, 2));
		//    
		Err := ZClose(typeDevice, numberDSP);
		ReadLn;
    Exit;
	end
	//     
	else
		//        
    WriteLn('First channel digital resolution: ', resolutionADC[0]:12:6);

	//      
	if numChannelsADC > 1 then
	begin
		//        
		Err := ZGetDigitalResolChanADC(typeDevice, numberDSP, 1, resolutionADC[1]);
		//     
		if Err <> 0 then
    begin
			//    
      WriteLn('ZGetDigitalResolChanADC() return Error = 0x', IntToHex(Err, 2));
			//    
			Err := ZClose(typeDevice, numberDSP);
			ReadLn;
      Exit;
		end
		else
		  //        
      WriteLn('Second channel digital resolution: ', resolutionADC[1]:12:6);
	end;

	//      
	Err := ZGetNumberInputADC(typeDevice, numberDSP, numChannelsADC);
	//     
	if Err <> 0 then
	begin
		//    
    WriteLn('ZGetNumberInputADC() return Error = 0x', IntToHex(Err, 2));
		//    
		Err := ZClose(typeDevice, numberDSP);
		ReadLn;
    Exit;
	end
	//     
	else
		//      
    WriteLn('Quantity of activated ADC channel: ', numChannelsADC);

	//        
	Err := ZGetWordsADC(typeDevice, numberDSP, numWordsADC);
	//     
	if Err <> 0 then
	begin
		//    
    WriteLn('ZGetWordsADC() return Error = 0x', IntToHex(Err, 2));
		//    
		Err := ZClose(typeDevice, numberDSP);
		ReadLn;
    Exit;
	end
	//     
	else
		//        
    WriteLn('Quantity of words: ', numWordsADC);

	//  ,     
	if(numWordsADC = 0) and (amplifyADC[0] = 0) or (amplifyADC[1] = 0) then
	begin
		//    
    WriteLn('Error ADC parameters');
		//    
		Err := ZClose(typeDevice, numberDSP);
		ReadLn;
    Exit;
	end;

  //   
	Err := ZGetBufferADC(typeDevice, numberDSP, pBuffer, sizeBufferADC);
	//     
	if Err <> 0 then
	begin
		//    
    WriteLn('ZGetBufferADC() return Error = 0x', IntToHex(Err, 2));
		//    
		Err := ZClose(typeDevice, numberDSP);
		ReadLn;
    Exit;
	end;

  //    
	Err := ZStopADC(typeDevice, numberDSP);
	//    
	Err := ZStartADC(typeDevice, numberDSP);

  //    
	while proc do
  begin
    //      
		Sleep(500);

    //      
		Err := ZGetPointerADC(typeDevice, numberDSP, pointerADC);
		//     
		if Err <> 0 then
		begin
			//    
      WriteLn('ZGetPointerADC() return Error = 0x', IntToHex(Err, 2));
			//   
			break;
		end;

		//         ,       
		if pointerADC = pointerADC_old then
			continue;

		//    
		pointerADC_old := pointerADC;

		//         
		if pointerADC - numWordsADC * numChannelsADC < 0 then
			pointerADC := sizeBufferADC + pointerADC - numWordsADC * numChannelsADC
		else
			pointerADC := pointerADC - numWordsADC * numChannelsADC;

		//          ( )   
		if numWordsADC = 1 then
    begin
      pBuffer16ADC := pBuffer;
      Inc(pBuffer16ADC, pointerADC);
      CopyMemory(@sample16ADC[0], pBuffer16ADC, 2);
      sampleADC[0] := sample16ADC[0];
    end
		else
    begin
      pBuffer32ADC := pBuffer;
      Inc(pBuffer32ADC, (pointerADC div numWordsADC));
      CopyMemory(@sample32ADC[0], pBuffer32ADC, 4);
      sampleADC[0] := sample32ADC[0];
    end;
    volt[0] := resolutionADC[0] * (sampleADC[0] / amplifyADC[0]);

		//       
    if numChannelsADC = 1 then
      WriteLn(volt[0]:12:6);

		//      
		if numChannelsADC > 1 then
		begin
			//     
			pointerADC := pointerADC + numWordsADC;

			//     ,    
			if pointerADC >= sizeBufferADC then
				pointerADC := pointerADC - sizeBufferADC;

			//          ( )   
			if numWordsADC = 1 then
      begin
        pBuffer16ADC := pBuffer;
        Inc(pBuffer16ADC, pointerADC);
        CopyMemory(@sample16ADC[1], pBuffer16ADC, 2);
        sampleADC[1] := sample16ADC[1];
      end
	  	else
      begin
        pBuffer32ADC := pBuffer;
        Inc(pBuffer32ADC, (pointerADC div numWordsADC));
        CopyMemory(@sample32ADC[1], pBuffer32ADC, 4);
        sampleADC[1] := sample32ADC[1];
      end;
	  	volt[1] := resolutionADC[1] * (sampleADC[1] / amplifyADC[1]);

			//       
      WriteLn(volt[0]:12:6, '   ', volt[1]:12:6);
		end;
	end;

	//    
	Err := ZStopADC(typeDevice, numberDSP);
	//     
	if Err <> 0 then
  	//    
    WriteLn('ZStopADC() return Error = 0x', IntToHex(Err, 2));

	//     
	Err := ZRemBufferADC(typeDevice, numberDSP, pBuffer);
 	//     
	if Err <> 0 then
	  //    
    WriteLn('ZRemBufferADC() return Error = 0x', IntToHex(Err, 2));

	//    
	Err := ZClose(typeDevice, numberDSP);
	//     
	if Err <> 0 then
		//    
    WriteLn('ZClose() return Error = 0x', IntToHex(Err, 2));

  WriteLn('Press any key for exit...');
  ReadLn;
end.
